
#ifndef _LQR_H_
#define _LQR_H_

#include <libxml/parser.h>
#include <libxml/tree.h>

#include <vl/Vld.h>
#include <vector>

class LQR
{
 public:
  LQR();

  LQR(xmlNodePtr root);
  
  ~LQR();

  void LTVLQR(const std::vector<Matd> &As,
	      const std::vector<Matd> &Bs,
	      const std::vector<Matd> &Qs,
	      const std::vector<Matd> &Rs,
	      const Matd &Qend,
	      double dt);

  
  void InfiniteHorizon(const Matd &A,
		       const Matd &B,
		       const Matd &Q,
		       const Matd &R,
		       double infT,
		       double dt);
  
  const Matd &GetK(double t) const;
  
  Vecd ComputeFeedback(double t, 
		       const Vecd &state,
		       const Vecd &desiredState) const;

  static bool IsRoot(xmlNodePtr root);
  
  xmlNodePtr Serialize() const;

  double ComputeCostToGo(double t,
			 const Vecd &state,
			 const Vecd &desiredState) const;
  
	const Matd &GetTerminalCostMatrix() const;
	
 private:

  struct M_Data;

  M_Data *m_data;

};
#endif
